/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the AddExternalIdRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AddExternalIdRequest{}

// AddExternalIdRequest struct for AddExternalIdRequest
type AddExternalIdRequest struct {
	SystemName *string `json:"system_name,omitempty"`
	UserLink *string `json:"user_link,omitempty"`
}

// NewAddExternalIdRequest instantiates a new AddExternalIdRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAddExternalIdRequest() *AddExternalIdRequest {
	this := AddExternalIdRequest{}
	return &this
}

// NewAddExternalIdRequestWithDefaults instantiates a new AddExternalIdRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAddExternalIdRequestWithDefaults() *AddExternalIdRequest {
	this := AddExternalIdRequest{}
	return &this
}

// GetSystemName returns the SystemName field value if set, zero value otherwise.
func (o *AddExternalIdRequest) GetSystemName() string {
	if o == nil || IsNil(o.SystemName) {
		var ret string
		return ret
	}
	return *o.SystemName
}

// GetSystemNameOk returns a tuple with the SystemName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AddExternalIdRequest) GetSystemNameOk() (*string, bool) {
	if o == nil || IsNil(o.SystemName) {
		return nil, false
	}
	return o.SystemName, true
}

// HasSystemName returns a boolean if a field has been set.
func (o *AddExternalIdRequest) HasSystemName() bool {
	if o != nil && !IsNil(o.SystemName) {
		return true
	}

	return false
}

// SetSystemName gets a reference to the given string and assigns it to the SystemName field.
func (o *AddExternalIdRequest) SetSystemName(v string) {
	o.SystemName = &v
}

// GetUserLink returns the UserLink field value if set, zero value otherwise.
func (o *AddExternalIdRequest) GetUserLink() string {
	if o == nil || IsNil(o.UserLink) {
		var ret string
		return ret
	}
	return *o.UserLink
}

// GetUserLinkOk returns a tuple with the UserLink field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AddExternalIdRequest) GetUserLinkOk() (*string, bool) {
	if o == nil || IsNil(o.UserLink) {
		return nil, false
	}
	return o.UserLink, true
}

// HasUserLink returns a boolean if a field has been set.
func (o *AddExternalIdRequest) HasUserLink() bool {
	if o != nil && !IsNil(o.UserLink) {
		return true
	}

	return false
}

// SetUserLink gets a reference to the given string and assigns it to the UserLink field.
func (o *AddExternalIdRequest) SetUserLink(v string) {
	o.UserLink = &v
}

func (o AddExternalIdRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AddExternalIdRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.SystemName) {
		toSerialize["system_name"] = o.SystemName
	}
	if !IsNil(o.UserLink) {
		toSerialize["user_link"] = o.UserLink
	}
	return toSerialize, nil
}

type NullableAddExternalIdRequest struct {
	value *AddExternalIdRequest
	isSet bool
}

func (v NullableAddExternalIdRequest) Get() *AddExternalIdRequest {
	return v.value
}

func (v *NullableAddExternalIdRequest) Set(val *AddExternalIdRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAddExternalIdRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAddExternalIdRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAddExternalIdRequest(val *AddExternalIdRequest) *NullableAddExternalIdRequest {
	return &NullableAddExternalIdRequest{value: val, isSet: true}
}

func (v NullableAddExternalIdRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAddExternalIdRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


